"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ui_1 = require("@sanity/ui");
var icons_1 = require("@sanity/icons");
var React = __importStar(require("react"));
var EditorField_1 = __importDefault(require("./EditorField"));
var LayoutsPicker_1 = __importDefault(require("./LayoutsPicker"));
var useEditorLogic_1 = __importDefault(require("./useEditorLogic"));
var DEFAULT_DIMENSIONS = {
    width: 1200,
    height: 630,
};
var Editor = function (props) {
    var _a, _b, _c, _d, _e;
    var _f = useEditorLogic_1.default(props), activeLayout = _f.activeLayout, setActiveLayout = _f.setActiveLayout, generateImage = _f.generateImage, disabled = _f.disabled, captureRef = _f.captureRef, data = _f.data, setData = _f.setData;
    var LayoutComponent = activeLayout.component;
    var fields = activeLayout.fields || [];
    var width = ((_a = activeLayout.dimensions) === null || _a === void 0 ? void 0 : _a.width) || DEFAULT_DIMENSIONS.width;
    var height = ((_b = activeLayout.dimensions) === null || _b === void 0 ? void 0 : _b.height) || DEFAULT_DIMENSIONS.height;
    return (React.createElement(ui_1.Card, { scheme: "light", height: "fill", sizing: "border", display: "flex", style: { flexDirection: 'column' } },
        React.createElement(ui_1.Card, { tone: "default", padding: 4, marginBottom: [4, 0], borderBottom: true, style: { textAlign: 'right' } },
            React.createElement(ui_1.Flex, { justify: "space-between", align: "center" },
                React.createElement(ui_1.Inline, { space: 3 },
                    React.createElement(ui_1.Text, { size: 3, weight: "semibold" }, ((_c = props.dialog) === null || _c === void 0 ? void 0 : _c.title) || 'Create image'),
                    React.createElement(ui_1.Button, { icon: disabled ? ui_1.Spinner : icons_1.GenerateIcon, tone: "positive", text: ((_d = props.dialog) === null || _d === void 0 ? void 0 : _d.finishCta) || 'Generate', onClick: generateImage, disabled: disabled })),
                props.onClose && (React.createElement(ui_1.Button, { onClick: props.onClose, icon: icons_1.CloseIcon, mode: "bleed", tone: "critical", title: ((_e = props.dialog) === null || _e === void 0 ? void 0 : _e.ariaClose) || 'close' })))),
        React.createElement(ui_1.Flex, { justify: "flex-start", align: "flex-start", wrap: "wrap", overflow: "auto", style: { width: '100%', height: 'auto', minHeight: '0' }, sizing: "border", padding: 3 },
            React.createElement(ui_1.Card, { padding: 3, marginRight: 4, style: { maxWidth: '350px', flex: '1 0 200px' }, sizing: "border" },
                React.createElement(ui_1.Stack, { space: 4 }, fields.map(function (field) { return (React.createElement(EditorField_1.default, { field: field, updateData: function (newData) { return setData(newData); }, data: data, disabled: disabled })); }))),
            React.createElement(ui_1.Card, { height: "fill", overflow: "auto", style: {
                    padding: '20px 10px',
                    maxWidth: width + 10 * 2 + "px",
                }, shadow: 3, sizing: "border" },
                React.createElement(ui_1.Stack, { space: 3 },
                    React.createElement(LayoutsPicker_1.default, { layouts: props.layouts, activeLayout: activeLayout, disabled: disabled, setActiveLayout: setActiveLayout }),
                    React.createElement("div", { style: {
                            width: width + "px",
                            height: height + "px",
                            boxSizing: 'border-box',
                        }, ref: captureRef },
                        React.createElement(LayoutComponent, __assign({}, data))))))));
};
exports.default = Editor;
