"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var default_1 = __importDefault(require("part:@sanity/components/formfields/default"));
var ui_1 = require("@sanity/ui");
var UNSUPORTED_TYPES = [
    'array',
    'date',
    'datetime',
    'image',
    'reference',
];
var EditorField = function (_a) {
    var _b;
    var field = _a.field, _c = _a.data, data = _c === void 0 ? {} : _c, updateData = _a.updateData, disabled = _a.disabled;
    if (!(field === null || field === void 0 ? void 0 : field.type) || !field.name || !updateData) {
        return null;
    }
    var label = field.title || field.name;
    var value = data[field.name] || undefined;
    if (UNSUPORTED_TYPES.includes(field.type)) {
        return (react_1.default.createElement(ui_1.Box, { marginTop: 2 },
            react_1.default.createElement(ui_1.Stack, { space: 2 },
                react_1.default.createElement(ui_1.Text, { size: 1, weight: "semibold" }, label),
                react_1.default.createElement(ui_1.Text, { size: 0 }, field.unsupportedError ||
                    'Close this dialog and edit the document to change this field.'))));
    }
    if (field.type === 'object') {
        if (!((_b = field.fields) === null || _b === void 0 ? void 0 : _b.length)) {
            return null;
        }
        // @TODO: fieldset
        return (react_1.default.createElement("div", null, field.fields.map(function (fld) { return (react_1.default.createElement(EditorField, { updateData: function (newData) {
                var _a;
                return updateData(__assign(__assign({}, data), (_a = {}, _a[field.name] = newData, _a)));
            }, field: fld, data: value, disabled: disabled })); })));
    }
    if (!['boolean', 'number', 'text', 'string'].includes(field.type)) {
        console.error('Asset-source OG Image: wrong field type received');
        return null;
    }
    function onChange(e) {
        var _a;
        var value = e.currentTarget.value || '';
        if (e.currentTarget.type === 'checkbox' && 'checked' in e.currentTarget) {
            value = e.currentTarget.checked;
        }
        if (e.currentTarget.type === 'number') {
            value = Number(value);
        }
        e.preventDefault();
        updateData(__assign(__assign({}, data), (_a = {}, _a[field.name] = value, _a)));
    }
    var commonProps = {
        onChange: onChange,
        value: value,
        disabled: disabled,
    };
    return (react_1.default.createElement(default_1.default, { label: label, description: field.description },
        field.type === 'boolean' && (react_1.default.createElement(ui_1.Switch, { checked: value === true, onChange: onChange })),
        field.type === 'text' && react_1.default.createElement(ui_1.TextArea, __assign({}, commonProps, { rows: 1 })),
        (field.type === 'string' || field.type === 'number') && (react_1.default.createElement(ui_1.TextInput, __assign({ type: field.type === 'number' ? 'number' : 'text' }, commonProps)))));
};
exports.default = EditorField;
