"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ui_1 = require("@sanity/ui");
var react_1 = __importDefault(require("react"));
var is_hotkey_1 = __importDefault(require("is-hotkey"));
var defaultLayout_1 = __importDefault(require("./defaultLayout"));
var Editor_1 = __importDefault(require("./Editor"));
var MediaEditor = function (props) {
    var _a;
    var handleGlobalKeyDown = react_1.default.useCallback(function (event) {
        // Close on escape key press
        if (is_hotkey_1.default('esc', event) && props.onClose) {
            props.onClose();
        }
    }, []);
    ui_1.useGlobalKeyDown(handleGlobalKeyDown);
    var layouts = (_a = props.layouts) === null || _a === void 0 ? void 0 : _a.filter(function (layout) { return layout.prepare && layout.component; });
    if (!(layouts === null || layouts === void 0 ? void 0 : layouts.length)) {
        layouts = [defaultLayout_1.default];
    }
    if (!(layouts === null || layouts === void 0 ? void 0 : layouts.length)) {
        if (props.onClose) {
            props.onClose();
        }
        return null;
    }
    var document = props.document || { _id: 'unknown' };
    var editorProps = {
        document: document,
        layouts: layouts,
        onSelect: props.onSelect,
        onClose: props.onClose,
        dialog: props.dialog,
    };
    return (react_1.default.createElement(ui_1.ThemeProvider, { theme: ui_1.studioTheme }, props.tool ? (react_1.default.createElement(ui_1.Box, { style: {
            height: '100%',
            position: 'relative',
        } },
        react_1.default.createElement(Editor_1.default, __assign({}, editorProps)))) : (react_1.default.createElement(ui_1.Portal, null,
        react_1.default.createElement(ui_1.Box, { style: {
                bottom: 0,
                height: 'auto',
                left: 0,
                position: 'fixed',
                top: 0,
                width: '100%',
                zIndex: 10000,
            } },
            react_1.default.createElement(Editor_1.default, __assign({}, editorProps)))))));
};
exports.default = MediaEditor;
