"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.defaultPrepare = exports.DefaultLayoutComponent = void 0;
var ui_1 = require("@sanity/ui");
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var Image_1 = __importDefault(require("./Image"));
var Title = styled_components_1.default.h1(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  font-size: 58px;\n  font-weight: 600;\n  margin: 0;\n"], ["\n  font-size: 58px;\n  font-weight: 600;\n  margin: 0;\n"])));
var SubTitle = styled_components_1.default.h2(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  font-size: 30px;\n  font-weight: 400;\n  margin: 0;\n"], ["\n  font-size: 30px;\n  font-weight: 400;\n  margin: 0;\n"])));
var LogoWrapper = styled_components_1.default.div(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  position: absolute;\n  right: 1em;\n  bottom: 1em;\n"], ["\n  position: absolute;\n  right: 1em;\n  bottom: 1em;\n"])));
var DefaultLayoutComponent = function (_a) {
    var title = _a.title, logo = _a.logo, subtitle = _a.subtitle, includeBorder = _a.includeBorder;
    return (React.createElement(ui_1.Card, { scheme: "light", style: {
            width: '100%',
            height: '100%',
            display: 'flex',
            alignItems: 'center',
            justifyContent: 'center',
            border: includeBorder ? '5px solid var(--card-border-color)' : 'none',
            boxSizing: 'border-box',
            textAlign: 'center',
            position: 'relative',
        }, padding: 3 },
        React.createElement(ui_1.Container, null,
            React.createElement(ui_1.Stack, { space: 3 },
                title && React.createElement(Title, null, title),
                subtitle && React.createElement(SubTitle, null, subtitle),
                React.createElement(LogoWrapper, null,
                    React.createElement(Image_1.default, { image: logo, width: 100 }))))));
};
exports.DefaultLayoutComponent = DefaultLayoutComponent;
// Ideally, users will provide their own prepare function, this is an unlikely fallback
var defaultPrepare = function (document) {
    var _a, _b, _c;
    return {
        // Possible common values for title & image
        title: document.title ||
            document.seoTitle | ((_a = document.seo) === null || _a === void 0 ? void 0 : _a.title) || ((_b = document.hero) === null || _b === void 0 ? void 0 : _b.title),
        logo: document.ogImage ||
            document.image || ((_c = document.hero) === null || _c === void 0 ? void 0 : _c.image) ||
            document.logo,
        includeBorder: false,
    };
};
exports.defaultPrepare = defaultPrepare;
var defaultLayout = {
    name: 'default',
    title: 'Default layout',
    component: exports.DefaultLayoutComponent,
    prepare: exports.defaultPrepare,
    fields: [
        {
            title: 'Title',
            name: 'title',
            type: 'string',
        },
        {
            title: 'Subtitle',
            name: 'subtitle',
            type: 'text',
        },
        {
            title: 'Logo / image',
            name: 'logo',
            type: 'image',
        },
        {
            title: 'Include borders',
            name: 'includeBorder',
            type: 'boolean',
        },
    ],
};
exports.default = defaultLayout;
var templateObject_1, templateObject_2, templateObject_3;
