"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var Image_1 = __importDefault(require("../Image"));
var blogPostInstagram = {
    name: 'blogPostInstagram',
    title: 'Blog post (Instagram)',
    // Start defining the form editors will fill to change the final image
    fields: [
        {
            name: 'title',
            type: 'string',
        },
        {
            name: 'subtitle',
            description: '❓ Optional',
            type: 'string',
        },
        {
            name: 'date',
            // ideally, it'd be a date, but that input isn't implemented yet
            type: 'string',
        },
        {
            name: 'authorImage',
            title: "Author's image",
            type: 'image',
            unsupportedError: 'We get this automatically from the chosen author. Close this dialog and change it in the document to reflect it here.',
        },
        {
            name: 'authorName',
            type: 'string',
        },
    ],
    prepare: function (document) {
        var _a, _b;
        return {
            title: document.title,
            subtitle: document.subtitle || document.excerpt,
            date: new Date(document._createdAt ? document._createdAt : Date.now()).toLocaleDateString('en'),
            authorImage: (_a = document.author) === null || _a === void 0 ? void 0 : _a.image,
            authorName: (_b = document.author) === null || _b === void 0 ? void 0 : _b.name,
        };
    },
    dimensions: {
        width: 1080,
        height: 1080,
    },
    component: function (_a) {
        var title = _a.title, subtitle = _a.subtitle, date = _a.date, authorImage = _a.authorImage, authorName = _a.authorName;
        return (react_1.default.createElement("div", null,
            react_1.default.createElement("h1", null, title || 'Please insert a title'),
            subtitle && react_1.default.createElement("h2", null, subtitle),
            date && react_1.default.createElement("div", null, date),
            authorImage && authorName && (react_1.default.createElement("div", { style: { display: 'flex', alignItems: 'center' } },
                react_1.default.createElement(Image_1.default, { image: authorImage, width: 100 }),
                authorName))));
    },
};
exports.default = blogPostInstagram;
