"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var Image_1 = __importDefault(require("../Image"));
// As this plugin's repo doesn't have css modules enabled, I'm not actually implementing styles
var css = {};
// I uploaded these in my Sanity studio and am using them as static data. I could pull this from the API or something like that, though ;)
var profilePic = {
    _type: 'image',
    asset: {
        _type: 'reference',
        _ref: 'image-1a67fe4bb878088e4857467f20fc221fe575e8ee-1059x1060-jpg',
    },
};
var svgPic = {
    _type: 'image',
    asset: {
        _type: 'reference',
        _ref: 'image-eea1db83cd7143c4229b5bc7f5c8f8b5ed4341ab-561x423-svg',
    },
};
var Component = function (_a) {
    var title = _a.title;
    return (react_1.default.createElement("div", { className: css.root },
        react_1.default.createElement("h1", { className: css.title }, title || 'Title missing'),
        react_1.default.createElement("div", { className: css.author },
            react_1.default.createElement(Image_1.default, { image: profilePic, width: 80 }),
            "Henrique Doro"),
        react_1.default.createElement("div", { className: css.svg },
            react_1.default.createElement(Image_1.default, { image: svgPic, width: 80 }))));
};
var hdoroDevOgImage = {
    name: 'hdoroDevOgImage',
    title: 'Hdoro.dev',
    component: Component,
    prepare: function (document) {
        return {
            title: document.title || document.seoTitle,
        };
    },
    fields: [
        {
            title: 'Post title',
            name: 'title',
            type: 'string',
        },
    ],
    dimensions: {
        width: 1200,
        height: 628,
    },
};
exports.default = hdoroDevOgImage;
