"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var Image_1 = __importDefault(require("../Image"));
var Component = function (_a) {
    var title = _a.title, intervieweeName = _a.intervieweeName, intervieweePhoto = _a.intervieweePhoto, quote = _a.quote;
    return (react_1.default.createElement("div", { style: {
            height: '100%',
            display: 'flex',
            alignItems: 'center',
            justifyContent: 'center',
            background: '#3333ee',
            border: '2px solid green',
            color: '#fff',
        } },
        react_1.default.createElement("div", null,
            react_1.default.createElement("div", null, "Your company's logo"),
            react_1.default.createElement("h1", null, title || 'Title'),
            quote && react_1.default.createElement("blockquote", null, quote),
            intervieweeName && react_1.default.createElement("p", null, intervieweeName),
            intervieweePhoto && react_1.default.createElement(Image_1.default, { image: intervieweePhoto, width: 300 }))));
};
var interviewTwitter = {
    name: 'interviewTwitter',
    title: 'Interview (Twitter)',
    component: Component,
    prepare: function (document) {
        var _a, _b;
        return {
            title: document.title || document.seoTitle,
            intervieweeName: (_a = document.author) === null || _a === void 0 ? void 0 : _a.name,
            intervieweePhoto: (_b = document.author) === null || _b === void 0 ? void 0 : _b.photo,
            quote: document.mainQuote,
        };
    },
    fields: [
        {
            title: 'Post title',
            name: 'title',
            type: 'string',
        },
        {
            title: 'Main quote',
            name: 'quote',
            type: 'text',
        },
        {
            title: 'Interviewee name',
            name: 'intervieweeName',
            type: 'string',
        },
        {
            title: 'Interviewee avatar',
            name: 'intervieweePhoto',
            type: 'image',
        },
    ],
    dimensions: {
        width: 1200,
        height: 630,
    },
};
exports.default = interviewTwitter;
