"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var Image_1 = __importDefault(require("../Image"));
var Component = function (_a) {
    var coverTitle = _a.coverTitle, duration = _a.duration, episodeTitle = _a.episodeTitle, episodeImage = _a.episodeImage, backgroundImage = _a.backgroundImage;
    return (react_1.default.createElement("div", { style: {
            height: '100%',
            display: 'flex',
            alignItems: 'center',
            justifyContent: 'center',
            background: 'papayawhip',
            border: '2px solid green',
        } },
        react_1.default.createElement("div", null,
            react_1.default.createElement(Image_1.default, { image: backgroundImage }),
            react_1.default.createElement("h1", null, coverTitle || 'Title'),
            react_1.default.createElement("div", null,
                react_1.default.createElement(Image_1.default, { image: episodeImage }),
                react_1.default.createElement("div", null,
                    episodeTitle && react_1.default.createElement("h2", null, episodeTitle),
                    duration && react_1.default.createElement("p", null,
                        duration,
                        " minutes"))),
            react_1.default.createElement("div", null, "Podcast logo"))));
};
var podcastInstagram = {
    name: 'podcastInstagram',
    title: 'Instagram podcast',
    component: Component,
    prepare: function (document) {
        return {
            duration: document.duration,
            coverTitle: document.description,
            episodeTitle: document.title,
            episodeImage: document.thumbnail,
            backgroundImage: document.coverArt,
        };
    },
    fields: [
        {
            name: 'duration',
            title: 'Duration in minutes',
            description: 'Make sure this is according to reality',
            type: 'number',
        },
        { name: 'coverTitle', title: 'Cover title', type: 'string' },
        { name: 'episodeTitle', title: 'Episode title', type: 'string' },
        { name: 'episodeImage', title: 'Episode Image', type: 'image' },
        { name: 'backgroundImage', title: 'backgroundImage', type: 'image' },
    ],
    dimensions: {
        width: 1080,
        height: 1080,
    },
};
exports.default = podcastInstagram;
